import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import TypeAnnotation from "../types/TypeAnnotation";
import ParentBodyPathProvider from "../../providers/ParentBodyPathProvider";
import Smart from "../Smart";
import { debugRef } from "../../util";
var Identifier = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      typeAnnotation = props.typeAnnotation;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "var ".concat(children).concat(typeAnnotation ? ': T' : '');

  function renderTypeAnnotation() {
    if (!typeAnnotation) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "typeAnnotation"
    }, typeof typeAnnotation === 'string' ? /*#__PURE__*/React.createElement(TypeAnnotation, null, typeAnnotation) : typeAnnotation, ";");
  }

  return /*#__PURE__*/React.createElement(Smart, {
    scopePath: "declarations.0.id",
    code: code,
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderTypeAnnotation(), children));
}.bind(this));
Identifier.defaultProps = {
  debug: false
};
export default Identifier;
//# sourceMappingURL=index.js.map