import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.map.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import BlockStatement from "../../BlockStatement";
import Code from "../../Code";
import Identifier from "../../Identifier";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeParameterDeclaration from "../../types/TypeParameterDeclaration";
import TypeReference from "../../types/TypeReference";
import { debugRef } from "../../../util";
var ClassDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      id = props.id,
      superClass = props.superClass,
      superTypeParameters = props.superTypeParameters,
      typeParameters = props.typeParameters;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "class ".concat(id, " {}");

  function renderSuperClass() {
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "superClass"
    }, typeof superClass === 'string' ? /*#__PURE__*/React.createElement(Identifier, null, superClass) : superClass);
  }

  function renderTypeParameter(typeParameter) {
    return typeof typeParameter === 'string' ? /*#__PURE__*/React.createElement(TypeReference, {
      name: typeParameter
    }) : typeParameter;
  }

  function renderTypeParameters() {
    if (!typeParameters) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "typeParameters"
    }, /*#__PURE__*/React.createElement(TypeParameterDeclaration, null, Array.isArray(typeParameters) ? typeParameters.map(renderTypeParameter) : renderTypeParameter(typeParameters)));
  }

  function renderSuperTypeParameters() {
    if (!superTypeParameters) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "superTypeParameters"
    }, /*#__PURE__*/React.createElement(TypeParameterDeclaration, null, Array.isArray(superTypeParameters) ? superTypeParameters.map(renderTypeParameter) : renderTypeParameter(superTypeParameters)));
  }

  function renderChildren() {
    if (typeof children === 'string') {
      return /*#__PURE__*/React.createElement(Code, null, children);
    }

    return children;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    deletePaths: "body.body",
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderSuperClass(), renderSuperTypeParameters(), renderTypeParameters(), /*#__PURE__*/React.createElement(BlockStatement, null, renderChildren())));
}.bind(this));
ClassDeclaration.defaultProps = {
  debug: false
};
export default ClassDeclaration;
//# sourceMappingURL=index.js.map