import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeAnnotation from "../../types/TypeAnnotation";
import { debugRef } from "../../../util";
var ClassProperty = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var accessibility = props.accessibility,
      children = props.children,
      debug = props.debug,
      id = props.id,
      typeAnnotation = props.typeAnnotation;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "class C {\n  ".concat(accessibility ? "".concat(accessibility, " ") : '').concat(id).concat(typeAnnotation ? ': T' : '').concat(typeof children !== 'undefined' ? " = ".concat(JSON.stringify(children)) : '', "\n}");

  function renderTypeAnnotation() {
    if (!typeAnnotation) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "typeAnnotation"
    }, typeof typeAnnotation === 'string' ? /*#__PURE__*/React.createElement(TypeAnnotation, null, typeAnnotation) : typeAnnotation);
  }

  return /*#__PURE__*/React.createElement(Smart, {
    scopePath: "body.body.0",
    code: code,
    ref: mergedRef
  }, renderTypeAnnotation());
}.bind(this));
export var ClassPropertyAccessibility;

(function (ClassPropertyAccessibility) {
  ClassPropertyAccessibility["Private"] = "private";
  ClassPropertyAccessibility["Protected"] = "protected";
  ClassPropertyAccessibility["Public"] = "public";
})(ClassPropertyAccessibility || (ClassPropertyAccessibility = {}));

ClassProperty.defaultProps = {
  debug: false
};
export default ClassProperty;
//# sourceMappingURL=index.js.map