import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.set.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var AssignmentExpression = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      left = props.left;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var childrenIsComponent = isComponent(children);
  var leftIsComponent = isComponent(left);

  function isComponent(value) {
    if (typeof value === 'undefined') return false;
    var valueKeys = new Set(Object.keys(value || {}));
    return valueKeys.has('$$typeof') && valueKeys.has('key') && valueKeys.has('props') && valueKeys.has('ref') && valueKeys.has('type');
  }

  var code = "".concat(leftIsComponent ? 'l' : left, " = ").concat(typeof children !== 'undefined' && !childrenIsComponent ? "".concat(JSON.stringify(children)) : 'undefined');

  function renderChildren() {
    if (!childrenIsComponent) return null;
    return children;
  }

  function renderLeft() {
    if (!leftIsComponent) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "left"
    }, left);
  }

  return /*#__PURE__*/React.createElement(Smart, {
    bodyPath: "right",
    code: code,
    deletePaths: leftIsComponent ? 'left' : undefined,
    ref: mergedRef,
    scopePath: "expression"
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderLeft(), renderChildren()));
}.bind(this));
AssignmentExpression.defaultProps = {
  debug: false
};
export default AssignmentExpression;
//# sourceMappingURL=index.js.map