import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Identifier from "../../Identifier";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var CallExpression = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      name = props.name;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "".concat(typeof children === 'undefined' ? '' : 'a.').concat(name, "()");

  function renderArgument(argument) {
    if (typeof argument === 'string') {
      return /*#__PURE__*/React.createElement(Identifier, null, argument);
    }

    return argument;
  }

  function renderArguments() {
    if (!props.arguments) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "arguments"
    }, Array.isArray(props.arguments) ? props.arguments.map(renderArgument) : renderArgument(props.arguments));
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    ref: mergedRef,
    scopePath: "expression",
    bodyPath: "callee.object"
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderArguments(), children));
}.bind(this));
CallExpression.defaultProps = {
  debug: false
};
export default CallExpression;
//# sourceMappingURL=index.js.map