import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";
import _pt from "prop-types";

var _this = this;

import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/es.array.reverse.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import AssignmentExpression from "../AssignmentExpression";
import Identifier from "../../Identifier";
import MemberExpression from "../MemberExpression";
import { debugRef } from "../../../util";
import CallExpression from "../CallExpression";
var Expression = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var call = props.call,
      children = props.children,
      debug = props.debug;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));

  function renderAssignmentExpression() {
    var properties = renderProperties((typeof props.properties === 'string' ? props.properties.split('.') : props.properties) || []);

    if (typeof children !== 'undefined') {
      return /*#__PURE__*/React.createElement(AssignmentExpression, {
        left: properties
      }, children);
    }

    return properties;
  }

  function renderProperties(properties) {
    var _this2 = this;

    var Comp = properties.reverse().reduce(function (Comp, property, i) {
      var _this3 = this;

      _newArrowCheck(this, _this2);

      var NewComp = function NewComp(_ref) {
        _newArrowCheck(this, _this3);

        var children = _ref.children;
        return /*#__PURE__*/React.createElement(Comp, null, call && i === 0 ? /*#__PURE__*/React.createElement(CallExpression, {
          arguments: props.arguments,
          name: property
        }, children) : /*#__PURE__*/React.createElement(MemberExpression, {
          name: property
        }, children));
      }.bind(this);

      NewComp.propTypes = {
        children: _pt.node
      };

      if (i === properties.length - 1) {
        NewComp = function NewComp() {
          _newArrowCheck(this, _this3);

          return /*#__PURE__*/React.createElement(Comp, null, call && properties.length <= 1 ? /*#__PURE__*/React.createElement(CallExpression, {
            arguments: props.arguments,
            name: property
          }) : /*#__PURE__*/React.createElement(Identifier, {
            ref: mergedRef
          }, property));
        }.bind(this);
      }

      return NewComp;
    }.bind(this), function (_ref2) {
      _newArrowCheck(this, _this2);

      var children = _ref2.children;
      return /*#__PURE__*/React.createElement(React.Fragment, null, children);
    }.bind(this));
    return /*#__PURE__*/React.createElement(Comp, null);
  }

  return renderAssignmentExpression();
}.bind(this));
Expression.defaultProps = {
  call: false,
  debug: false
};
export default Expression;
//# sourceMappingURL=index.js.map