import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import BlockStatement from "../../BlockStatement";
import Code from "../../Code";
import Identifier from "../../Identifier";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeAnnotation from "../../types/TypeAnnotation";
import { debugRef } from "../../../util";
var MethodSignature = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      id = props.id,
      debug = props.debug,
      returnType = props.returnType,
      params = props.params;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "interface I { ".concat(id, "()").concat(returnType ? ': T' : '', "; }");

  function renderChildren() {
    if (typeof children === 'string') {
      return /*#__PURE__*/React.createElement(Code, null, children);
    }

    return children;
  }

  function renderReturnType() {
    if (!returnType) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "typeAnnotation"
    }, typeof returnType === 'string' ? /*#__PURE__*/React.createElement(TypeAnnotation, null, returnType) : returnType, ";");
  }

  function renderParams() {
    var _this2 = this;

    if (!(params !== null && params !== void 0 && params.length)) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "parameters"
    }, params.map(function (param) {
      _newArrowCheck(this, _this2);

      if (typeof param === 'string') {
        return /*#__PURE__*/React.createElement(Identifier, null, param);
      }

      return param;
    }.bind(this)));
  }

  return /*#__PURE__*/React.createElement(Smart, {
    scopePath: "body.body.0",
    code: code,
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderReturnType(), renderParams(), /*#__PURE__*/React.createElement(BlockStatement, null, renderChildren())));
}.bind(this));
MethodSignature.defaultProps = {
  debug: false
};
export default MethodSignature;
//# sourceMappingURL=index.js.map