import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeAnnotation from "../../types/TypeAnnotation";
import { debugRef } from "../../../util";
var PropertySignature = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var debug = props.debug,
      id = props.id,
      typeAnnotation = props.typeAnnotation;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "interface I {\n  ".concat(id).concat(typeAnnotation ? ': T' : '', ";\n}");

  function renderTypeAnnotation() {
    if (!typeAnnotation) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "typeAnnotation"
    }, typeof typeAnnotation === 'string' ? /*#__PURE__*/React.createElement(TypeAnnotation, null, typeAnnotation) : typeAnnotation);
  }

  return /*#__PURE__*/React.createElement(Smart, {
    scopePath: "body.body.0",
    code: code,
    ref: mergedRef
  }, renderTypeAnnotation());
}.bind(this));
PropertySignature.defaultProps = {
  debug: false
};
export default PropertySignature;
//# sourceMappingURL=index.js.map