import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import JSXExpressionContainer from "../JSXExpressionContainer";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var JSXAttribute = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      name = props.name,
      debug = props.debug;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "<J ".concat(name).concat(typeof children === 'string' ? "=".concat(JSON.stringify(children)) : '', " />");

  function renderChildren() {
    if (typeof children === 'undefined' || typeof children === 'string' || children === null) {
      return null;
    }

    return /*#__PURE__*/React.createElement(JSXExpressionContainer, null, children);
  }

  return /*#__PURE__*/React.createElement(Smart, {
    scopePath: "expression.openingElement.attributes.0",
    bodyPath: "value",
    code: code,
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderChildren()));
}.bind(this));
JSXAttribute.defaultProps = {
  debug: false
};
export default JSXAttribute;
//# sourceMappingURL=index.js.map