import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import JSXClosingElement from "../JSXClosingElement";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
import JSXOpeningElement from "../JSXOpeningElement";
var JSXElement = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var attributes = props.attributes,
      selfClosing = props.selfClosing,
      children = props.children,
      debug = props.debug,
      name = props.name;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "<".concat(typeof name === 'undefined' ? '' : 'E').concat(children || !name ? "></".concat(typeof name === 'undefined' ? '' : 'E') : ' /', ">");

  function renderOpeningElement() {
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "openingElement"
    }, /*#__PURE__*/React.createElement(JSXOpeningElement, {
      attributes: attributes,
      name: name,
      selfClosing: !children && selfClosing
    }));
  }

  function renderClosingElement() {
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "closingElement"
    }, /*#__PURE__*/React.createElement(JSXClosingElement, {
      name: name
    }));
  }

  function renderChildren() {
    return children;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    scopePath: "expression",
    bodyPath: "children",
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderOpeningElement(), renderClosingElement(), renderChildren()));
}.bind(this));
JSXElement.defaultProps = {
  debug: false,
  selfClosing: true
};
export default JSXElement;
//# sourceMappingURL=index.js.map