import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.set.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.object.keys.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var JSXExpressionContainer = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  var _this2 = this;

  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));

  var isComponent = function () {
    _newArrowCheck(this, _this2);

    if (typeof children === 'undefined') return false;
    var childrenKeys = new Set(Object.keys(children || {}));
    return childrenKeys.has('$$typeof') && childrenKeys.has('key') && childrenKeys.has('props') && childrenKeys.has('ref') && childrenKeys.has('type');
  }.bind(this)();

  var code = "<J a={".concat(typeof children !== 'undefined' && !isComponent ? "".concat(JSON.stringify(children)) : 'a', "} />");

  function renderChildren() {
    if (isComponent) return children;
    return null;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    bodyPath: "expression",
    code: code,
    deletePaths: typeof children !== 'undefined' && !isComponent ? undefined : 'expression',
    ref: mergedRef,
    scopePath: "expression.openingElement.attributes.0.value"
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderChildren()));
}.bind(this));
JSXExpressionContainer.defaultProps = {
  debug: false
};
export default JSXExpressionContainer;
//# sourceMappingURL=index.js.map