import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _typeof from "@babel/runtime/helpers/typeof";
import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.set.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.object.entries.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import JSXAttribute from "../JSXAttribute";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var JSXOpeningElement = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var attributes = props.attributes,
      debug = props.debug,
      name = props.name,
      selfClosing = props.selfClosing;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "<".concat(typeof name === 'undefined' ? '' : name).concat(typeof name !== 'undefined' && selfClosing ? ' /' : "></".concat(typeof name === 'undefined' ? '' : name), ">");

  function isComponent(value) {
    if (typeof value === 'undefined') return false;
    var childrenKeys = new Set(Object.keys(value || {}));
    return childrenKeys.has('$$typeof') && childrenKeys.has('key') && childrenKeys.has('props') && childrenKeys.has('ref') && childrenKeys.has('type');
  }

  function renderAttribute(attribute, name) {
    if (name) {
      return /*#__PURE__*/React.createElement(JSXAttribute, {
        name: name
      }, attribute === true ? undefined : attribute);
    }

    if (typeof attribute === 'string') {
      return /*#__PURE__*/React.createElement(JSXAttribute, {
        name: attribute
      });
    }

    if (isComponent(attribute)) return attribute;
    return null;
  }

  function renderAttributes() {
    var _this2 = this;

    if (!attributes) return null;

    if (typeof attributes === 'string') {
      return /*#__PURE__*/React.createElement(JSXAttribute, {
        name: attributes
      });
    }

    if (isComponent(attributes)) return attributes;

    if (Array.isArray(attributes)) {
      return attributes.map(function (attribute) {
        _newArrowCheck(this, _this2);

        return renderAttribute(attribute);
      }.bind(this));
    }

    if (_typeof(attributes) === 'object') {
      return Object.entries(attributes).map(function (_ref) {
        _newArrowCheck(this, _this2);

        var _ref2 = _slicedToArray(_ref, 2),
            name = _ref2[0],
            attribute = _ref2[1];

        return renderAttribute(attribute, name);
      }.bind(this));
    }

    return null;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    ref: mergedRef,
    bodyPath: "attributes",
    scopePath: "expression.openingElement"
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderAttributes()));
}.bind(this));
JSXOpeningElement.defaultProps = {
  debug: false,
  selfClosing: false
};
export default JSXOpeningElement;
//# sourceMappingURL=index.js.map