import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import Code from "../../Code";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var ExportDefaultDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = 'export default d';

  function renderChildren() {
    if (typeof children === 'string') {
      return /*#__PURE__*/React.createElement(Code, null, children);
    }

    return children;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    bodyPath: "declaration",
    code: code,
    deletePaths: "declaration",
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderChildren()));
}.bind(this));
ExportDefaultDeclaration.defaultProps = {
  debug: false
};
export default ExportDefaultDeclaration;
//# sourceMappingURL=index.js.map