import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.map.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import Code from "../../Code";
import ExportSpecifier from "../ExportSpecifier";
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var ExportNamedDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      source = props.source,
      specifiers = props.specifiers;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "export {}".concat(source ? " from '".concat(source, "'") : '');

  function renderChildren() {
    if (typeof children === 'string') {
      return /*#__PURE__*/React.createElement(Code, null, children);
    }

    return children;
  }

  function renderSpecifier(specifier) {
    if (typeof specifier === 'string') {
      return /*#__PURE__*/React.createElement(ExportSpecifier, null, specifier);
    }

    return specifier;
  }

  function renderSpecifiers() {
    if (!specifiers) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "specifiers"
    }, Array.isArray(specifiers) ? specifiers.map(renderSpecifier) : renderSpecifier(specifiers));
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    bodyPath: "declaration",
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderSpecifiers(), renderChildren()));
}.bind(this));
ExportNamedDeclaration.defaultProps = {
  debug: false
};
export default ExportNamedDeclaration;
//# sourceMappingURL=index.js.map