import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.array.map.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import ImportSpecifier from "../ImportSpecifier";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var ImportDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var debug = props.debug,
      defaultSpecifier = props.defaultSpecifier,
      namespaceSpecifier = props.namespaceSpecifier,
      source = props.source,
      specifiers = props.specifiers;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "import ".concat(namespaceSpecifier ? " * as ".concat(namespaceSpecifier) : defaultSpecifier || 'I', " from '").concat(source, "'");

  function renderSpecifier(specifier) {
    if (typeof specifier === 'string') {
      return /*#__PURE__*/React.createElement(ImportSpecifier, null, specifier);
    }

    return specifier;
  }

  function renderSpecifiers() {
    if (!specifiers || namespaceSpecifier) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "specifiers"
    }, Array.isArray(specifiers) ? specifiers.map(renderSpecifier) : renderSpecifier(specifiers));
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    deletePaths: defaultSpecifier || namespaceSpecifier ? undefined : 'specifiers.0',
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderSpecifiers()));
}.bind(this));
ImportDeclaration.defaultProps = {
  debug: false
};
export default ImportDeclaration;
//# sourceMappingURL=index.js.map