import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeReference from "../TypeReference";
import { debugRef } from "../../../util";
var TypeParameterDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = 'class C<T> {}';

  function renderChildren() {
    if (typeof children === 'string') {
      return /*#__PURE__*/React.createElement(TypeReference, {
        name: children
      });
    }

    return children;
  }

  return /*#__PURE__*/React.createElement(Smart, {
    bodyPath: "params",
    code: code,
    deletePaths: "params.0",
    ref: mergedRef,
    scopePath: "typeParameters"
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, renderChildren()));
}.bind(this));
TypeParameterDeclaration.defaultProps = {
  debug: false
};
export default TypeParameterDeclaration;
//# sourceMappingURL=index.js.map