import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.function.name.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import { debugRef } from "../../../util";
import VariableDeclarator from "../VariableDeclarator";
import VariableDeclaration, { VariableDeclarationKind } from "../VariableDeclaration";
var Var = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      kind = props.kind,
      typeAnnotation = props.typeAnnotation,
      name = props.name;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  return /*#__PURE__*/React.createElement(VariableDeclaration, {
    kind: kind,
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(VariableDeclarator, {
    id: name,
    typeAnnotation: typeAnnotation
  }, children));
}.bind(this));
export var VarKind;

(function (VarKind) {
  VarKind[VarKind["Const"] = VariableDeclarationKind.Const] = "Const";
  VarKind[VarKind["Let"] = VariableDeclarationKind.Let] = "Let";
  VarKind[VarKind["Var"] = VariableDeclarationKind.Var] = "Var";
})(VarKind || (VarKind = {}));

Var.defaultProps = {
  debug: false,
  kind: VarKind.Var
};
export default Var;
//# sourceMappingURL=index.js.map