import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import { debugRef } from "../../../util";
var VariableDeclaration = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      kind = props.kind;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));
  var code = "".concat(kind, " v = 0");
  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    deletePaths: "declarations.0",
    bodyPath: "declarations",
    ref: mergedRef
  }, /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
    value: undefined
  }, children));
}.bind(this));
export var VariableDeclarationKind;

(function (VariableDeclarationKind) {
  VariableDeclarationKind["Const"] = "const";
  VariableDeclarationKind["Let"] = "let";
  VariableDeclarationKind["Var"] = "var";
})(VariableDeclarationKind || (VariableDeclarationKind = {}));

VariableDeclaration.defaultProps = {
  debug: false,
  kind: VariableDeclarationKind.Var
};
export default VariableDeclaration;
//# sourceMappingURL=index.js.map