import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

var _this = this;

import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.set.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.array.concat.js";
import React, { forwardRef } from 'react';
import useMergedRef from '@react-hook/merged-ref';
import ParentBodyPathProvider from "../../../providers/ParentBodyPathProvider";
import Smart from "../../Smart";
import TypeAnnotation from "../../types/TypeAnnotation";
import { debugRef } from "../../../util";
var VariableDeclarator = /*#__PURE__*/forwardRef(function (props, forwardedRef) {
  var _this2 = this;

  _newArrowCheck(this, _this);

  var children = props.children,
      debug = props.debug,
      id = props.id,
      typeAnnotation = props.typeAnnotation;
  var mergedRef = useMergedRef(forwardedRef, debugRef(debug));

  var isComponent = function () {
    _newArrowCheck(this, _this2);

    if (typeof children === 'undefined') return false;
    var childrenKeys = new Set(Object.keys(children || {}));
    return childrenKeys.has('$$typeof') && childrenKeys.has('key') && childrenKeys.has('props') && childrenKeys.has('ref') && childrenKeys.has('type');
  }.bind(this)();

  var code = "var ".concat(id).concat(typeAnnotation ? ': T' : '').concat(typeof children !== 'undefined' && !isComponent ? " = ".concat(JSON.stringify(children)) : '');

  function renderChildren() {
    if (!isComponent || typeof children === 'undefined') return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "init"
    }, children);
  }

  function renderTypeAnnotation() {
    if (!typeAnnotation) return null;
    return /*#__PURE__*/React.createElement(ParentBodyPathProvider, {
      value: "id.typeAnnotation"
    }, typeof typeAnnotation === 'string' ? /*#__PURE__*/React.createElement(TypeAnnotation, null, typeAnnotation) : typeAnnotation, ";");
  }

  return /*#__PURE__*/React.createElement(Smart, {
    code: code,
    ref: mergedRef,
    scopePath: "declarations.0"
  }, renderTypeAnnotation(), renderChildren());
}.bind(this));
VariableDeclarator.defaultProps = {
  debug: false
};
export default VariableDeclarator;
//# sourceMappingURL=index.js.map