import "core-js/modules/es.symbol.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.object.get-own-property-descriptor.js";
import "core-js/modules/es.object.get-own-property-descriptors.js";
import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import "core-js/modules/es.array.splice.js";
import "core-js/modules/es.array.index-of.js";
import "core-js/modules/web.dom-collections.for-each.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.function.name.js";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import PropTypes from 'prop-types';
import _get from 'lodash.get';
import _set from 'lodash.set';
import { flattenPath } from "../util";

var BaseElement = /*#__PURE__*/function () {
  function BaseElement(baseNode) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var meta = arguments.length > 2 ? arguments[2] : undefined;

    _classCallCheck(this, BaseElement);

    this.node = void 0;
    this.props = void 0;
    this.children = [];
    this.meta = {
      bodyPath: 'body',
      parentBodyPath: null
    };
    if (Array.isArray(baseNode)) throw new Error('cannot be array');

    if (meta) {
      this.meta = _objectSpread(_objectSpread({}, this.meta), meta);
    }

    this.node = baseNode;
    this.props = this.getProps(props);
  }

  _createClass(BaseElement, [{
    key: "getBodyPath",
    value: function getBodyPath(path) {
      return flattenPath(path || this.meta.bodyPath);
    }
  }, {
    key: "getBody",
    value: function getBody(body, path) {
      var bodyPath = this.getBodyPath(path);
      if (!bodyPath.length) return body;
      return _get(body, bodyPath);
    }
  }, {
    key: "setBody",
    value: function setBody(body, value, path) {
      var bodyPath = this.getBodyPath(path);
      if (!bodyPath.length) return body;
      return _set(body, bodyPath, value);
    }
  }, {
    key: "appendChild",
    value: function appendChild(child) {
      var body = this.getBody(this.node, child.meta.parentBodyPath);
      this.children.push(child);

      if (Array.isArray(body)) {
        body.push(child.node);
      } else {
        this.setBody(this.node, child.node, child.meta.parentBodyPath);
      }
    }
  }, {
    key: "removeChild",
    value: function removeChild(child) {
      var body = this.getBody(this.node, child.meta.parentBodyPath);
      if (!body || !Array.isArray(body)) return;
      this.children.splice(this.children.indexOf(child), 1);
      body.splice(body.indexOf(child.node), 1);
    }
  }, {
    key: "commitMount",
    value: function commitMount() {
      return undefined;
    }
  }, {
    key: "commitUpdate",
    value: function commitUpdate(newProps) {
      this.props = _objectSpread(_objectSpread({}, this.props), newProps);
    }
  }, {
    key: "getProps",
    value: function getProps(props) {
      var _this = this;

      props = _objectSpread({}, props);
      var _ref = this.constructor,
          defaultProps = _ref.defaultProps,
          propTypes = _ref.propTypes;
      Object.keys(defaultProps).forEach(function (key) {
        _newArrowCheck(this, _this);

        var defaultProp = defaultProps[key];

        if (typeof props[key] === 'undefined' || props[key] === null) {
          props[key] = defaultProp;
        }
      }.bind(this));
      PropTypes.checkPropTypes(propTypes, props, 'prop', this.constructor.name);
      return props;
    }
  }]);

  return BaseElement;
}();

BaseElement.defaultProps = {};
BaseElement.propTypes = {};
export { BaseElement as default };
//# sourceMappingURL=BaseElement.js.map