import "core-js/modules/es.reflect.construct.js";
import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";

var _this2 = this;

import "core-js/modules/web.dom-collections.for-each.js";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import _get from 'lodash.get';
import _merge from 'lodash.merge';
import template from '@babel/template';
import { flattenPath, deletePath } from "../util";
import BaseElement from "./BaseElement";

var SmartElement = /*#__PURE__*/function (_BaseElement) {
  _inherits(SmartElement, _BaseElement);

  var _super = _createSuper(SmartElement);

  function SmartElement(props) {
    var _this = this;

    var parserOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, SmartElement);

    var baseNode = template.smart(props.code, _merge(parserOptions, props.options))(props.replacements);
    var scopePath = flattenPath(props.scopePath);
    var node = props.scopePath && scopePath.length ? _get(baseNode, scopePath) : baseNode;
    var deletePaths = Array.isArray(props.deletePaths || []) ? props.deletePaths || [] : [props.deletePaths];
    deletePaths.forEach(function (path) {
      _newArrowCheck(this, _this);

      return deletePath(node, path);
    }.bind(this));
    return _super.call(this, node, props, {
      bodyPath: props.bodyPath || 'body',
      parentBodyPath: props.parentBodyPath
    });
  }

  return SmartElement;
}(BaseElement);

SmartElement.defaultProps = {
  bodyPath: 'body',
  children: null,
  deletePaths: [],
  options: {},
  ref: function ref(f) {
    _newArrowCheck(this, _this2);

    return f;
  }.bind(this),
  replacements: {},
  scopePath: ''
};
export { SmartElement as default };
//# sourceMappingURL=SmartElement.js.map