import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.object.get-own-property-descriptor.js";
import "core-js/modules/web.dom-collections.for-each.js";
import "core-js/modules/es.object.get-own-property-descriptors.js";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import "core-js/modules/es.number.constructor.js";
import "core-js/modules/es.array.concat.js";
import * as t from '@babel/types';
import generate from '@babel/generator';
import parserBabel from 'prettier/parser-babel';
import prettier from 'prettier/standalone';
import Renderer from "./reconciler";
import { File } from "./elements";
import { dev } from "./util";
import { updateContext } from "./context";
export function renderAst(element) {
  var _this = this;

  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var ast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : t.file(t.program([]), [], []);
  updateContext({
    parserOptions: options.parserOptions || {}
  });
  var file = new File();
  file.node = ast;
  var root = Renderer.createContainer(file, 0, false, null);
  Renderer.updateContainer(element, root, null, function () {// noop

    _newArrowCheck(this, _this);
  }.bind(this));
  Renderer.injectIntoDevTools({
    bundleType: Number(dev),
    rendererPackageName: 'react-ast',
    version: '0.2' // version: pkg.version

  });
  return file.node;
}
export function render(element) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var ast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : t.file(t.program([]), [], []);
  options = _objectSpread({
    prettier: true
  }, options);

  var _generate = generate(renderAst(element, options, ast), options.generatorOptions || {}),
      code = _generate.code;

  if (options.prettier) {
    var _options, _options$prettier;

    return prettier.format(code, _objectSpread(_objectSpread({}, typeof options.prettier === 'boolean' ? {} : options.prettier), {}, {
      plugins: [parserBabel].concat(_toConsumableArray(((_options = options) === null || _options === void 0 ? void 0 : (_options$prettier = _options.prettier) === null || _options$prettier === void 0 ? void 0 : _options$prettier.plugins) || []))
    }));
  }

  return code;
}
//# sourceMappingURL=render.js.map