import _newArrowCheck from "@babel/runtime/helpers/newArrowCheck";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.array.join.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.array.flat.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.split.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.number.is-nan.js";
import "core-js/modules/es.number.constructor.js";
import "core-js/modules/es.array.splice.js";
import _get from 'lodash.get';
var logger = console;
var g = typeof window === 'undefined' ? global : window;
var process = typeof g.process === 'undefined' ? {
  env: {}
} : g.process;
export function flattenPath(path) {
  var _this = this;

  if (typeof path !== 'number' && !path) return '';
  if (!Array.isArray(path)) return path.toString();
  return path.flat().filter(function (s) {
    _newArrowCheck(this, _this);

    return s.toString().length;
  }.bind(this)).join('.');
}
export function deletePath(value, path) {
  if (typeof value === 'undefined') return false;
  var pathArr = flattenPath(path).split('.');
  var key = pathArr.slice(pathArr.length - 1)[0];
  key = Number.isNaN(Number(key)) ? key : Number(key);
  var parentDeletePath = pathArr.slice(0, pathArr.length - 1).join('.');
  var parent = parentDeletePath ? _get(value, parentDeletePath) : value;
  if (typeof parent === 'undefined') return false;

  if (Array.isArray(parent) && typeof key === 'number') {
    var _result = parent.length > key;

    parent.splice(key, 1);
    return _result;
  }

  var result = (key in parent);
  delete parent[key];
  return result;
}

function isDev() {
  if (typeof process.env.NODE_ENV === 'undefined') {
    return typeof process.env.__DEV__ === 'undefined' ? false : process.env.__DEV__.toLowerCase() !== 'false';
  }

  return process.env.NODE_ENV.toLowerCase() !== 'prod' || process.env.NODE_ENV.toLowerCase() !== 'production';
}

export function debugRef() {
  var _this2 = this;

  var debug = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  if (!debug) return function () {
    _newArrowCheck(this, _this2);

    return undefined;
  }.bind(this);
  return function (ref) {
    _newArrowCheck(this, _this2);

    return logger.debug(JSON.stringify(ref.node, null, 2));
  }.bind(this);
}
export var dev = isDev();
//# sourceMappingURL=util.js.map