import React from 'react';
import BaseElement from '~/elements/BaseElement';
import { VariableDeclaratorProps } from '~/components/variables/VariableDeclarator';
import { VariableDeclarationProps } from '~/components/variables/VariableDeclaration';
export interface VarProps extends Omit<VariableDeclarationProps, 'children' | 'kind'>, Omit<VariableDeclaratorProps, 'id'> {
    kind?: VarKind;
    name: string;
}
declare const Var: React.ForwardRefExoticComponent<VarProps & React.RefAttributes<BaseElement>>;
export declare enum VarKind {
    Const = "const",
    Let = "let",
    Var = "var"
}
export default Var;
