(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./elements", "./context"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./elements"), require("./context"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elements, global.context);
    global.createElement = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _elements, _context) {
  "use strict";

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = createElement;
  _elements = _interopRequireDefault(_elements);

  function createElement(elementType, props) {
    var _getContext = (0, _context.getContext)(),
        parserOptions = _getContext.parserOptions;

    var Element = _elements.default[elementType];
    if (!Element) throw new Error("unknown element of type '".concat(elementType, "'"));
    return new Element(props, parserOptions);
  }
});
//# sourceMappingURL=createElement.js.map