import { ParserOptions } from '@babel/parser';
import { BaseNode, HashMap, Path, Node, Instance, Props } from '~/types';
export interface IElement<P = Props> {
    new (props?: P, parserOptions?: ParserOptions): BaseElement;
    propTypes: HashMap;
    defaultProps: Props;
}
export interface Meta {
    bodyPath: Path;
    parentBodyPath: Path | null;
}
export default class BaseElement implements Instance {
    static defaultProps: Props;
    static propTypes: HashMap;
    node: Node;
    props: Props;
    children: BaseElement[];
    meta: Meta;
    getBodyPath(path?: Path | null): string;
    getBody(body: BaseNode | BaseNode[], path?: Path | null): BaseNode | BaseNode[];
    setBody(body: BaseNode | BaseNode[], value: BaseNode | BaseNode[], path?: Path | null): BaseNode | BaseNode[];
    constructor(baseNode: BaseNode | BaseNode[], props?: Props, meta?: Partial<Meta>);
    appendChild(child: BaseElement): void;
    removeChild(child: BaseElement): void;
    commitMount(): undefined;
    commitUpdate(newProps: Props): void;
    getProps(props: Props): Props;
}
