require("core-js/modules/es.symbol.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "core-js/modules/es.array.splice.js", "core-js/modules/es.array.index-of.js", "core-js/modules/web.dom-collections.for-each.js", "core-js/modules/es.object.keys.js", "core-js/modules/es.function.name.js", "@babel/runtime/helpers/newArrowCheck", "@babel/runtime/helpers/defineProperty", "@babel/runtime/helpers/classCallCheck", "@babel/runtime/helpers/createClass", "prop-types", "lodash.get", "lodash.set", "../util"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("core-js/modules/es.array.splice.js"), require("core-js/modules/es.array.index-of.js"), require("core-js/modules/web.dom-collections.for-each.js"), require("core-js/modules/es.object.keys.js"), require("core-js/modules/es.function.name.js"), require("@babel/runtime/helpers/newArrowCheck"), require("@babel/runtime/helpers/defineProperty"), require("@babel/runtime/helpers/classCallCheck"), require("@babel/runtime/helpers/createClass"), require("prop-types"), require("lodash.get"), require("lodash.set"), require("../util"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.esArraySplice, global.esArrayIndexOf, global.webDomCollectionsForEach, global.esObjectKeys, global.esFunctionName, global.newArrowCheck, global.defineProperty, global.classCallCheck, global.createClass, global.propTypes, global.lodash, global.lodash, global.util);
    global.BaseElement = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _esArraySplice, _esArrayIndexOf, _webDomCollectionsForEach, _esObjectKeys, _esFunctionName, _newArrowCheck2, _defineProperty2, _classCallCheck2, _createClass2, _propTypes, _lodash, _lodash2, _util) {
  "use strict";

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _newArrowCheck2 = _interopRequireDefault(_newArrowCheck2);
  _defineProperty2 = _interopRequireDefault(_defineProperty2);
  _classCallCheck2 = _interopRequireDefault(_classCallCheck2);
  _createClass2 = _interopRequireDefault(_createClass2);
  _propTypes = _interopRequireDefault(_propTypes);
  _lodash = _interopRequireDefault(_lodash);
  _lodash2 = _interopRequireDefault(_lodash2);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  var BaseElement = /*#__PURE__*/function () {
    function BaseElement(baseNode) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var meta = arguments.length > 2 ? arguments[2] : undefined;
      (0, _classCallCheck2.default)(this, BaseElement);
      this.node = void 0;
      this.props = void 0;
      this.children = [];
      this.meta = {
        bodyPath: 'body',
        parentBodyPath: null
      };
      if (Array.isArray(baseNode)) throw new Error('cannot be array');

      if (meta) {
        this.meta = _objectSpread(_objectSpread({}, this.meta), meta);
      }

      this.node = baseNode;
      this.props = this.getProps(props);
    }

    (0, _createClass2.default)(BaseElement, [{
      key: "getBodyPath",
      value: function getBodyPath(path) {
        return (0, _util.flattenPath)(path || this.meta.bodyPath);
      }
    }, {
      key: "getBody",
      value: function getBody(body, path) {
        var bodyPath = this.getBodyPath(path);
        if (!bodyPath.length) return body;
        return (0, _lodash.default)(body, bodyPath);
      }
    }, {
      key: "setBody",
      value: function setBody(body, value, path) {
        var bodyPath = this.getBodyPath(path);
        if (!bodyPath.length) return body;
        return (0, _lodash2.default)(body, bodyPath, value);
      }
    }, {
      key: "appendChild",
      value: function appendChild(child) {
        var body = this.getBody(this.node, child.meta.parentBodyPath);
        this.children.push(child);

        if (Array.isArray(body)) {
          body.push(child.node);
        } else {
          this.setBody(this.node, child.node, child.meta.parentBodyPath);
        }
      }
    }, {
      key: "removeChild",
      value: function removeChild(child) {
        var body = this.getBody(this.node, child.meta.parentBodyPath);
        if (!body || !Array.isArray(body)) return;
        this.children.splice(this.children.indexOf(child), 1);
        body.splice(body.indexOf(child.node), 1);
      }
    }, {
      key: "commitMount",
      value: function commitMount() {
        return undefined;
      }
    }, {
      key: "commitUpdate",
      value: function commitUpdate(newProps) {
        this.props = _objectSpread(_objectSpread({}, this.props), newProps);
      }
    }, {
      key: "getProps",
      value: function getProps(props) {
        var _this = this;

        props = _objectSpread({}, props);
        var _ref = this.constructor,
            defaultProps = _ref.defaultProps,
            propTypes = _ref.propTypes;
        Object.keys(defaultProps).forEach(function (key) {
          (0, _newArrowCheck2.default)(this, _this);
          var defaultProp = defaultProps[key];

          if (typeof props[key] === 'undefined' || props[key] === null) {
            props[key] = defaultProp;
          }
        }.bind(this));

        _propTypes.default.checkPropTypes(propTypes, props, 'prop', this.constructor.name);

        return props;
      }
    }]);
    return BaseElement;
  }();

  _exports.default = BaseElement;
  BaseElement.defaultProps = {};
  BaseElement.propTypes = {};
});
//# sourceMappingURL=BaseElement.js.map