(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Ast", "./ExpressionElement", "./File", "./Program", "./SmartElement"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Ast"), require("./ExpressionElement"), require("./File"), require("./Program"), require("./SmartElement"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Ast, global.ExpressionElement, global.File, global.Program, global.SmartElement);
    global.index = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _Ast, _ExpressionElement, _File, _Program, _SmartElement) {
  "use strict";

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "Ast", {
    enumerable: true,
    get: function get() {
      return _Ast.default;
    }
  });
  Object.defineProperty(_exports, "ExpressionElement", {
    enumerable: true,
    get: function get() {
      return _ExpressionElement.default;
    }
  });
  Object.defineProperty(_exports, "File", {
    enumerable: true,
    get: function get() {
      return _File.default;
    }
  });
  Object.defineProperty(_exports, "Program", {
    enumerable: true,
    get: function get() {
      return _Program.default;
    }
  });
  Object.defineProperty(_exports, "SmartElement", {
    enumerable: true,
    get: function get() {
      return _SmartElement.default;
    }
  });
  _exports.default = void 0;
  _Ast = _interopRequireDefault(_Ast);
  _ExpressionElement = _interopRequireDefault(_ExpressionElement);
  _File = _interopRequireDefault(_File);
  _Program = _interopRequireDefault(_Program);
  _SmartElement = _interopRequireDefault(_SmartElement);
  var _default = {
    Ast: _Ast.default,
    ExpressionElement: _ExpressionElement.default,
    File: _File.default,
    Program: _Program.default,
    SmartElement: _SmartElement.default
  };
  _exports.default = _default;
});
//# sourceMappingURL=index.js.map