require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "core-js/modules/es.object.to-string.js", "core-js/modules/es.regexp.to-string.js", "core-js/modules/web.queue-microtask.js", "@babel/runtime/helpers/defineProperty", "react-reconciler", "./createElement", "./elements", "./util"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("core-js/modules/es.object.to-string.js"), require("core-js/modules/es.regexp.to-string.js"), require("core-js/modules/web.queue-microtask.js"), require("@babel/runtime/helpers/defineProperty"), require("react-reconciler"), require("./createElement"), require("./elements"), require("./util"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.esObjectToString, global.esRegexpToString, global.webQueueMicrotask, global.defineProperty, global.reactReconciler, global.createElement, global.elements, global.util);
    global.reconciler = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _esObjectToString, _esRegexpToString, _webQueueMicrotask, _defineProperty2, _reactReconciler, _createElement, _elements, _util) {
  "use strict";

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  _defineProperty2 = _interopRequireDefault(_defineProperty2);
  _reactReconciler = _interopRequireDefault(_reactReconciler);
  _createElement = _interopRequireDefault(_createElement);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  var logger = _objectSpread(_objectSpread({}, console), {}, {
    debug: function debug() {
      return undefined;
    }
  }); // bindings to the react reconciliation lifecycle methods


  var _default = (0, _reactReconciler.default)({
    createInstance: function createInstance(type, props, _rootContainerInstance, _hostContext) {
      logger.debug('createInstance');
      return (0, _createElement.default)(type, props);
    },
    appendInitialChild: function appendInitialChild(parentInstance, child) {
      logger.debug('appendInitialChild');
      parentInstance.appendChild(child);
    },
    finalizeInitialChildren: function finalizeInitialChildren(_parentInstance, _type, _props, _rootContainerInstance, _hostContext) {
      logger.debug('finalizeInitialChildren');
      return true;
    },
    createTextInstance: function createTextInstance(text, _rootContainerInstance, _hostContext) {
      logger.debug('createTextInstance');
      var label = new _elements.SmartElement({
        code: text
      }, {});
      label.commitMount(); // prob should run at a later point

      return label;
    },
    getPublicInstance: function getPublicInstance(instance) {
      logger.debug('getPublicInstance');
      return instance;
    },
    prepareForCommit: function prepareForCommit(_containerInfo) {
      logger.debug('prepareForCommit');
      return null;
    },
    prepareUpdate: function prepareUpdate(_instance, _type, _oldProps, _newProps, _rootContainerInstance, _hostContext) {
      logger.debug('prepareUpdate');
      return true;
    },
    resetAfterCommit: function resetAfterCommit(_containerInfo) {
      logger.debug('resetAfterCommit');
    },
    resetTextContent: function resetTextContent(_instance) {
      logger.debug('resetTextContent'); // noop
    },
    commitTextUpdate: function commitTextUpdate(_textInstance, _oldText, _newText) {
      logger.debug('commitTextUpdate');
      throw new Error('commitTextUpdate should not be called');
    },
    removeChild: function removeChild(parentInstance, child) {
      logger.debug('removeChild');
      parentInstance.removeChild(child);
    },
    removeChildFromContainer: function removeChildFromContainer(_container, _child) {
      logger.debug('removeChildFromContainer');
      if (_util.dev) logger.warn("'removeChildFromContainer' not supported");
    },
    insertBefore: function insertBefore(_parentInstance, _child, _beforeChild) {
      logger.debug('insertBefore');
      if (_util.dev) logger.warn("'insertBefore' not supported");
    },
    appendChildToContainer: function appendChildToContainer(container, child) {
      logger.debug('appendChildToContainer');
      container.appendChild(child);
    },
    appendChild: function appendChild(parentInstance, child) {
      logger.debug('appendChild');
      parentInstance.appendChild(child);
    },
    shouldSetTextContent: function shouldSetTextContent(_type, props) {
      logger.debug('shouldSetTextContent');
      if (typeof props.children === 'string') return true;
      return false;
    },
    getRootHostContext: function getRootHostContext(_rootContainerInstance) {
      logger.debug('getRootHostContext');
      if (_util.dev) logger.warn("'getRootHostContext' not supported");
      return {};
    },
    getChildHostContext: function getChildHostContext(_parentHostContext, _type, _rootContainerInstance) {
      logger.debug('getChildHostContext');
      if (_util.dev) logger.warn("'getChildHostContext' not supported");
      return {};
    },
    now: Date.now,
    commitUpdate: function commitUpdate(instance, _updatePayload, _type, _oldProps, newProps) {
      logger.debug('commitUpdate');
      return instance.commitUpdate(newProps);
    },
    commitMount: function commitMount(instance, _type, _newProps) {
      logger.debug('commitMount');
      instance.commitMount();
    },
    scheduleTimeout: function scheduleTimeout(handler, timeout) {
      logger.debug('setTimeout');
      return setTimeout(handler, timeout);
    },
    cancelTimeout: function cancelTimeout(handle) {
      logger.debug('clearTimeout');
      return clearTimeout(handle);
    },
    preparePortalMount: function preparePortalMount() {
      logger.debug('preparePortalMount');
    },
    queueMicrotask: function (_queueMicrotask) {
      function queueMicrotask(_x) {
        return _queueMicrotask.apply(this, arguments);
      }

      queueMicrotask.toString = function () {
        return _queueMicrotask.toString();
      };

      return queueMicrotask;
    }(function (callback) {
      queueMicrotask(callback);
    }),
    clearContainer: function clearContainer(_container) {
      logger.debug('clearContainer');
    },
    noTimeout: -1,
    isPrimaryRenderer: true,
    supportsMutation: true,
    supportsPersistence: false,
    supportsHydration: false
  });

  _exports.default = _default;
});
//# sourceMappingURL=reconciler.js.map